/*
 *  TOPPERS/A-CANIF
 *      Automotive CANIF
 *
 *  Copyright (C) 2013-2015 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2013-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2014-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2013-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *  Copyright (C) 2013-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2013-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2013-2015 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: CanIf_Types.h 1241 2015-03-25 07:26:02Z panasonic-ayane $
 */

#ifndef CANIF_TYPES_H
#define CANIF_TYPES_H

#include "ComStack_Types.h"     /* [CANIF643] */
#include "Can_GeneralTypes.h"   /* [CANIF142] */

typedef enum {
	CANIF_CS_UNINIT = 0,
	CANIF_CS_SLEEP = 1,
	CANIF_CS_STARTED = 2,
	CANIF_CS_STOPPED = 3
} CanIf_ControllerModeType;

typedef enum {
	CANIF_SET_OFFLINE = 0,
	CANIF_SET_ONLINE = 1,
	CANIF_SET_RX_OFFLINE = 2,
	CANIF_SET_RX_ONLINE = 3,
	CANIF_SET_TX_OFFLINE = 4,
	CANIF_SET_TX_OFFLINE_ACTIVE = 5,
	CANIF_SET_TX_ONLINE = 6
} CanIf_PduSetModeType;

typedef enum {
	CANIF_GET_OFFLINE = 0,
	CANIF_GET_OFFLINE_ACTIVE = 1,
	CANIF_GET_OFFLINE_ACTIVE_RX_ONLINE = 2,
	CANIF_GET_ONLINE = 3,
	CANIF_GET_RX_ONLINE = 4,
	CANIF_GET_TX_ONLINE = 5
} CanIf_PduGetModeType;

typedef enum {
	CANIF_NO_NOTIFICATION = 0,
	CANIF_TX_RX_NOTIFICATION = 1
} CanIf_NotifStatusType;

#endif /* CANIF_TYPES_H */
